<template>
  <div
    class="query-builder-group p-3x bd-rds-sm bd-1"
    :class="[`depth-${depth}`, { 'mt-2x': depth > 1 }]"
  >
    <div class="query-builder-group__header">
      <div class="row row-xs items-center">
        <div v-if="!disable" class="col-auto">
          <b-radio-group
            v-model="query.logicalOperator"
            mini
            @change="handleLogicalOperatorChange"
          >
            <b-radio-button
              v-for="label in labels.matchTypes"
              :key="label.id"
              :label="label.id"
            >
              {{ labels.matchType + ' ' + label.label.toLowerCase() }}
            </b-radio-button>
          </b-radio-group>
        </div>
        <div v-else class="col-auto">
          <b-button primary small disabled style="opacity: 1">{{
            labels.matchType +
            ' ' +
            labels.matchTypes.find((item) => item.id == query.logicalOperator)
              .label
          }}</b-button>
        </div>
        <div class="col"></div>
        <div v-if="!disable" class="col-auto">
          <b-button-text
            v-if="depth > 1"
            xsmall
            danger
            prefix-icon="control-minus"
            @click="removeGroup"
            >{{ labels.removeGroup }}</b-button-text
          >
        </div>
      </div>
    </div>

    <template v-for="(item, _index) in query.childRules">
      <query-builder-group
        v-if="item.type === 'query-builder-group'"
        :key="item.id || _index"
        v-model="item.query"
        :rules="rules"
        :labels="labels"
        :max-depth="maxDepth"
        :depth="depth + 1"
        :index="_index"
        :disable="disable"
        @input="handleQueryBuilderChange"
        @deletion="handleQueryBuilderDeletion"
      />
      <query-builder-rule
        v-if="item.type === 'query-builder-rule'"
        :key="item.id || _index"
        v-model="item.query"
        :rules="rules"
        :labels="labels"
        :index="_index"
        :disable="disable"
        @input="handleQueryBuilderChange"
        @deletion="handleQueryBuilderDeletion"
      >
      </query-builder-rule>
    </template>

    <b-divider class="my-3x mxi-3x"></b-divider>
    <div v-if="!disable" class="query-builder-group__footer">
      <div class="row row-xs items-center">
        <div class="col-3" style="display: contents">
          <div class="mr-2x">Attribute:</div>
          <b-select v-model="selectedRule" value-key="name">
            <b-option
              v-for="rule in rules"
              :key="rule.name"
              :value="rule"
              :label="rule.label"
            >
            </b-option>
          </b-select>
        </div>
        <div class="col-auto">
          <b-button primary small @click.prevent="addRule">{{
            labels.addRule
          }}</b-button>
        </div>
        <div v-if="depth < maxDepth" class="col-auto">
          <p class="text-sm c-grey-5 px-2x">&mdash; OR &mdash;</p>
        </div>
        <div class="col-auto">
          <b-button
            v-if="depth < maxDepth"
            primary
            small
            @click.prevent="addGroup"
            >{{ labels.addGroup }}</b-button
          >
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { cloneDeep } from 'lodash'
import { objectUtils } from '../../utils/index'
import QueryBuilderRule from './QueryBuilderRule'

export default {
  name: 'QueryBuilderGroup',
  components: {
    QueryBuilderRule,
  },
  props: {
    rules: {
      type: Array,
      default() {
        return []
      },
    },
    labels: {
      type: Object,
      default() {
        return {}
      },
    },
    maxDepth: {
      type: Number,
      default: 3,
      validator(value) {
        return value >= 1
      },
    },
    depth: {
      type: Number,
      default: 1,
    },
    index: {
      type: Number,
      default: 0,
    },
    value: {
      type: Object,
      default() {
        return {}
      },
    },
    disable: {
      type: Boolean,
      default() {
        return false
      },
    },
  },
  data() {
    return {
      query: cloneDeep(this.value),
      selectedRule: this.rules[0],
    }
  },
  created() {
    this.query.childRules = this.query.childRules.filter(
      (item) =>
        item.type === 'query-builder-group' ||
        this.rules.find((r) => r.name === item.query.attributeName)
    )
    this.$emit('input', this.query)
  },
  methods: {
    handleLogicalOperatorChange() {
      this.$emit('input', this.query)
    },
    handleQueryBuilderChange() {
      this.$emit('input', this.query)
    },
    handleQueryBuilderDeletion(index) {
      this.query.childRules.splice(index, 1)
      this.$emit('input', this.query)
    },

    addRule() {
      const child = {
        id: objectUtils.mongoObjectId(),
        type: 'query-builder-rule',
        query: {
          operator: this.selectedRule.operators?.length
            ? this.selectedRule.operators[0].key
            : null,
          fromValue: null,
          toValue: null,
          segmentContent: null,
          segmentPositionStart: 0,
          segmentPositionEnd: 1000,
          attributeName: this.selectedRule.name,
          attributeType: this.selectedRule.attributeType
            ? this.selectedRule.attributeType
            : null,
          documentId: '',
          target: 1,
        },
      }

      this.query.childRules.push(child)
      this.$emit('input', this.query)
    },
    addGroup() {
      if (this.depth < this.maxDepth) {
        this.query.childRules.push({
          id: objectUtils.mongoObjectId(),
          type: 'query-builder-group',
          query: {
            logicalOperator: this.labels.matchTypes[0].id,
            childRules: [],
          },
        })
        this.$emit('input', this.query)
      }
    },
    removeGroup() {
      this.$emit('deletion', this.index)
    },
  },
}
</script>
